【POJ - 3250 Bad Hair Day (单调栈)】临文乍了了,彻卷兀若无。这篇文章主要讲述POJ - 3250 Bad Hair Day (单调栈)相关的知识,希望能为你提供帮助。
题干:
Some of Farmer Johns
N
cows (1 ≤
N
≤ 80,000) are having a bad hair day! Since each cow is self-conscious about her messy hairstyle, FJ wants to count the number of other cows that can see the top of other cows heads.
Each cow
i
has a specified height
hi
(1 ≤
hi
≤ 1,000,000,000) and is standing in a line of cows all facing east (to the right in our diagrams). Therefore, cow
i
can see the tops of the heads of cows in front of her (namely cows
i+1,
i+2, and so on), for as long as these cows are strictly shorter than cow
i.
Consider this example:
=
==
=-=Cows facing right -->
===
= - = = =
= = = = = =
1 2 3 4 5 6
Cow#1 can see the hairstyle of cows #2, 3, 4
Cow#2 can see no cows hairstyle
Cow#3 can see the hairstyle of cow #4
Cow#4 can see no cows hairstyle
Cow#5 can see the hairstyle of cow 6
Cow#6 can see no cows at all!
Let ci denote the number of cows whose hairstyle is visible from cow i; please compute the sum of c1 through cN.For this example, the desired is answer 3 + 0 + 1 + 0 + 1 + 0 = 5.
Input
Line 1: The number of cows, N.
Lines 2..N+1: Line i+1 contains a single integer that is the height of cow i.
Output
Line 1: A single integer that is the sum of c 1 through cN.
Sample Input
6
10
3
7
4
12
2
Sample Output
5
解题报告:
此题给出两种单调栈的写法
ac代码1:
#include< cstdio>
#include< iostream>
#include< cstring>
#include< stack>
using namespace std;
const int MAX = 80000 + 5 ;
int h[MAX],r[MAX];
stack < int> sk;
long long sum=0;
int main()
int n;
cin> > n;
for(int i = 1; i< =n; i++)
scanf("%d",& h[i]);
for(int i = n; i> =1; i--)
//维护一个从右向左单调递增减栈 //即存的是右侧第一个比自己大的元素
while(!sk.empty() & & h[sk.top() ] < h[i] ) sk.pop(); //注意这里不能写=!!!
if(sk.empty() ) r[i]=n+1;
else r[i]=sk.top();
sk.push(i);
for(int i = 1; i< =n; i++)
sum+=r[i]-i-1;
printf("%lld\\n",sum);
return 0 ;
ac代码2:(别人写)
#include< iostream>
#include< cstdio>
#include< stack>
#include< algorithm>
using namespace std;
typedef long long LL;
int main()
int n;
while(~scanf("%d",& n))
stack< int> S;
int t;
scanf("%d",& t);
S.push(t);
LL ans=0;
for(int i=1; i< n; i++)
scanf("%d",& t);
while(!S.empty()& & t> =S.top())S.pop();
ans+=S.size();
S.push(t);
printf("%lld\\n",ans);
return 0;
/*
单调栈-----所谓单调栈也就是每次加入一个新元素时,把栈中小于等于这个值的元素弹出。
接下来回到这道题。求所有牛总共能看到多少牛,可以转化为:这n头牛共能被多少头牛看见。
当我们新加入一个高度值时,如果栈中存在元素小于新加入的高度值,
那么这些小的牛肯定看不见这个高度的牛(那就看不见这头牛后边的所有牛),
所以就可以把这些元素弹出。每次加入新元素,并执行完弹出操作后,
栈中元素个数便是可以看见这个牛的“牛数”~~~。
*/
总结:
看好单调栈到底取不取等号!一个是严格单调一个不是严格单调 这很关键。
还有一种思路:??代码??
我们现在只要构建一个严格单调递减栈就行了对吧?假如我栈中现在有了N头牛,按照从大到小排列,那么再加入一个高度更矮的我就再直接加入栈就好啦!但是来了一头高个牛该怎么办呢?,那么我们只需要把高度低于这头牛的牛出栈就可以了不是吗?而且喽,我们在出栈的时候让出栈的这头牛的下标和现在加入的这头牛的下标相减的绝对值再减掉一就是目前出栈的这头牛可以看到的牛的头数对吧?但是最后我们还需要将栈中的全部牛出栈该怎么办呢?这时候我们只需要定义一个哨兵牛初始化为高度无限大再入栈的话前面的牛自然不就出栈了吗?
推荐阅读
- *HDU - 2473Junk-Mail Filter (并查集--删点操作)
- *HDU - 1506POJ - 2559Largest Rectangle in a Histogram(单调栈或动态规划)
- CF#459 A Pashmak and Garden(水题)
- HDU - 1870愚人节的礼物(水题模拟 思想类似于栈())
- CF#-931A Friends Meeting(思维)
- 什么是真正的敏捷开发(敏捷开发与瀑布开发有何不同)
- CF#468 div2 D. Peculiar apple-tree(思维)
- HDU - 1301Jungle Roads(并查集+最小生成树)(内附最小生成树两种算法 克鲁斯特尔算法&&普里姆算法)
- client-go gin的简单整合七-继续完善